#include <vcl\vcl.h>
#pragma hdrstop
#include <vcl\registry.hpp>
#include <shellapi.h>

#include "codeexp_demo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCodeExpDemo *CodeExpDemo;
//---------------------------------------------------------------------------
__fastcall TCodeExpDemo::TCodeExpDemo(TComponent* Owner)
    : TForm(Owner)
{ TRegistry *reg=new TRegistry();
  AnsiString cust="";
  reg->OpenKey("Software\\Lu\\Codegen",true);
  try {cust=reg->ReadString("Custom");}
  catch (ERegistryException &err) {}
  delete reg;
  cbCustom->Text=cust;
  cbCustomChange(this);
}
//---------------------------------------------------------------------------


void __fastcall TCodeExpDemo::cbCustomChange(TObject *Sender)
{ bool run=FileExists(cbCustom->Text) || (cbCustom->Text.Length()>=1 && cbCustom->Text[1]=='*');
  bool edit=run && FileExists("codemac.exe") && (cbCustom->Text.Length()>=1 && cbCustom->Text[1]!='*');
  tEdit->Enabled=edit;
  btnEdit->Enabled=edit;
  tRun->Enabled=run;
  btnRun->Enabled=run;
}
//---------------------------------------------------------------------------

void __fastcall TCodeExpDemo::FormActivate(TObject *Sender)
{ AnsiString OldText=cbCustom->Text;
  cbCustom->Clear();
  cbCustom->Items->Add("*BuiltIn");
  char c[MAX_PATH];
  GetModuleFileName(HInstance,c,MAX_PATH);
  AnsiString mod=AnsiString(c);
  AnsiString dir=ExtractFilePath(mod);
  AnsiString search=dir+"*.mac";
  WIN32_FIND_DATA fd;
  HANDLE hFind=FindFirstFile(search.c_str(),&fd);
  while (hFind!=INVALID_HANDLE_VALUE)
  { AnsiString fn=AnsiString(fd.cFileName);
    cbCustom->Items->Add(dir+fn);
    BOOL more=FindNextFile(hFind,&fd);
    if (!more) {FindClose(hFind);hFind=INVALID_HANDLE_VALUE;}
  }
  if (OldText=="" && cbCustom->Items->Count>0) OldText=cbCustom->Items->Strings[0];
  //
  cbCustom->Text=OldText;
}
//---------------------------------------------------------------------------

void __fastcall TCodeExpDemo::btnEditClick(TObject *Sender)
{ ShellExecute(Application->Handle,"open","CodeMac.exe",cbCustom->Text.c_str(),NULL,SW_SHOW);
}
//---------------------------------------------------------------------------

void __fastcall TCodeExpDemo::btnRunClick(TObject *Sender)
{ TRegistry *reg=new TRegistry();
  reg->OpenKey("Software\\Lu\\Codegen",true);
  reg->WriteString("Custom",cbCustom->Text);
  delete reg;
}
//---------------------------------------------------------------------------

void __fastcall TCodeExpDemo::btnNewClick(TObject *Sender)
{ ShellExecute(Application->Handle,"open","CodeMac.exe","/new",NULL,SW_SHOW);
}
//---------------------------------------------------------------------------

