#include <vcl\vcl.h>
#pragma hdrstop
USERES("CodeExp.res");
USEPACKAGE("vclx35.bpi");
USEPACKAGE("VCL35.bpi");
USEFORM("codeexp_demo.cpp", CodeExpDemo);
USEUNIT("codeexp_codegen.cpp");
USEUNIT("codeexp_codegenp.pas");
//---------------------------------------------------------------------------
#include <vcl\exptintf.hpp>
#include "codeexp_demo.h"
#include "codeexp_codegen.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
class __declspec(delphiclass) TCodeExp : public TIExpert
{
public:
 __fastcall TCodeExp() {hicon=LoadIcon(HInstance,"CODEEXP");};
 __fastcall virtual ~TCodeExp() {};
 AnsiString __stdcall GetName()    {return "CodeExp";}
 AnsiString __stdcall GetAuthor()  {return "Lucian Wischik";}
 AnsiString __stdcall GetComment() {return "For making file-new experts";}
 AnsiString __stdcall GetPage()    {return "New";}
 HICON __stdcall GetGlyph()        {return hicon;}
 TExpertStyle __stdcall GetStyle() {return esProject;}
 TExpertState __stdcall GetState() {TExpertState es; es << esEnabled; return es;};
 AnsiString __stdcall GetIDString(){return "WISCHIK.CODEEXP";}
 AnsiString __stdcall GetMenuText(){return "CodeExp";};
 void __stdcall Execute();
protected:
 HICON hicon;
};
//---------------------------------------------------------------------------
void __stdcall TCodeExp::Execute()
{ try
  { TCodeExpDemo *f=new TCodeExpDemo(Application);
    int res=f->ShowModal();
    AnsiString s=f->cbCustom->Text;
    delete f;
    if (res==mrOk) CodeGen(s,s,NULL);
  }
  catch(...)
  { Application->MessageBox("An exception occurred in the expert","Error",MB_OK);
  }
}



//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*) {return 1;}
namespace Codeexp
{ void __fastcall PACKAGE Register() {RegisterLibraryExpert(new TCodeExp());}
}

