#ifndef codeexp_codegenH
#define codeexp_codegenH

// CODEGEN - executes the named macro script file thing.
// Name may be a filename "my_stuff.mac" or a resource name "*resourcename"
// Title will be the title displayed in message boxes &c. in case of error
// Vals are strings in the form key=value for initial key values. May be null.
void __fastcall CodeGen(AnsiString Name,AnsiString Title,TStrings *vals);


// PARSE - preprocesses the specified macro file
typedef AnsiString __fastcall (__closure *TCodeGenGetValueFunc)(const AnsiString key,bool *b);
typedef void __fastcall (__closure *TCodeGenErrorFunc)(const AnsiString mess);
AnsiString __fastcall CodeGenParse(TStream *sin,TCodeGenGetValueFunc gv,TCodeGenErrorFunc onerr);


#endif
