//---------------------------------------------------------------------------
#ifndef f_editH
#define f_editH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "ColMemo.hpp"
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TEditForm : public TForm
{
__published:	// IDE-managed Components
    TMemo *KeysMemo;
    TSplitter *Splitter1;
    TSplitter *Splitter2;
    TColorMemo *MacMemo;
    TMemo *OutputMemo;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Exit1;
    TMenuItem *N1;
    TMenuItem *SaveAs1;
    TMenuItem *Save1;
    TMenuItem *Open1;
    TMenuItem *New1;
    TMenuItem *View1;
    TMenuItem *Output1;
    TMenuItem *Keys1;
    TMenuItem *Openkeys1;
    TMenuItem *Savekeys1;
    TOpenDialog *OpenMacDialog;
    TSaveDialog *SaveMacDialog;
    TOpenDialog *OpenKeysDialog;
    TSaveDialog *SaveKeysDialog;
    TMenuItem *N2;
    TMenuItem *Edit1;
    TMenuItem *mPaste;
    TMenuItem *mCopy;
    TMenuItem *mCut;
    TMenuItem *N3;
    TMenuItem *mUndo;
    TMenuItem *Savekeysas1;
    TMenuItem *Help1;
    TMenuItem *About;
    void __fastcall Output1Click(TObject *Sender);
    void __fastcall Keys1Click(TObject *Sender);
    void __fastcall New1Click(TObject *Sender);
    void __fastcall MacMemoChange(TObject *Sender);
    void __fastcall KeysMemoChange(TObject *Sender);
    void __fastcall Open1Click(TObject *Sender);
    void __fastcall Save1Click(TObject *Sender);
    void __fastcall SaveAs1Click(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall Openkeys1Click(TObject *Sender);
    void __fastcall Savekeys1Click(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall mCutClick(TObject *Sender);
    void __fastcall mCopyClick(TObject *Sender);
    void __fastcall mPasteClick(TObject *Sender);
    void __fastcall Edit1Click(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall mUndoClick(TObject *Sender);
    void __fastcall Savekeysas1Click(TObject *Sender);
    void __fastcall AboutClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TEditForm(TComponent* Owner);
    bool MacDirty; AnsiString FFileName;
    bool __fastcall CheckCloseMac();
    bool __fastcall CheckCloseKeys(); int KeysCount;
    __property AnsiString FileName = {read=FFileName,write=SetFileName};
    AnsiString KeysName;
    bool FOutputDirty;
    void __fastcall SetFileName(AnsiString s);
    void __fastcall OutputDirty(); void __fastcall OutputRender();
    AnsiString __fastcall GetValueFunc(const AnsiString key,bool *found);
    void __fastcall TouchRC();
};
//---------------------------------------------------------------------------
extern PACKAGE TEditForm *EditForm;
//---------------------------------------------------------------------------
#endif
 